/*
 * FMDLog
 * Wideband O2 Display/Datalogging Application
 * For the TechEdge DIY-WB series of devices
 * (c) 2002-2003, Jonathan Burchmore
 *
 * Your use of this software is governed by the GNU General Public License, v2.
 * See the file COPYING.txt, or http://www.fsf.org/copyleft/gpl.txt
 *
 * This software is provided with ABSOLUTELY NO WARRANTY.  See the GNU General
 * public license for additional information.
 */

#include <PalmOS.h>
#include "resource.h"
#include "fmdlog.h"

/*
 * Color Dialog
 */

IndexedColorType	color_afr, color_rpm, color_v1, color_v2;
IndexedColorType	new_color_afr, new_color_rpm, new_color_v1, new_color_v2;

void ColorForm_DrawBars()
{
	RectangleType rect;
	IndexedColorType last_color;

	rect.topLeft.x	= 5;
	rect.extent.x	= 100;
	rect.extent.y	= 10;

	rect.topLeft.y	= 19;
	last_color		= WinSetForeColor( new_color_afr );
	WinDrawRectangle( &rect, 0 );
	WinSetForeColor( last_color );

	rect.topLeft.y	+= 17;
	last_color		= WinSetForeColor( new_color_rpm );
	WinDrawRectangle( &rect, 0 );
	WinSetForeColor( last_color );

	rect.topLeft.y	+= 17;
	last_color		= WinSetForeColor( new_color_v1 );
	WinDrawRectangle( &rect, 0 );
	WinSetForeColor( last_color );

	rect.topLeft.y	+= 17;
	last_color		= WinSetForeColor( new_color_v2 );
	WinDrawRectangle( &rect, 0 );
	WinSetForeColor( last_color );
}

Boolean ColorForm_HandleEvent( EventPtr event )
{
	FormPtr frm;

	if ( event->eType == frmOpenEvent )
	{
		frm				= FrmGetActiveForm();

		new_color_afr	= color_afr;
		new_color_rpm	= color_rpm;
		new_color_v1	= color_v1;
		new_color_v2	= color_v2;

		FrmDrawForm( frm );
		ColorForm_DrawBars();

		return true;
	}
	else if ( event->eType == ctlSelectEvent )
	{
		frm	= FrmGetActiveForm();

		switch ( event->data.ctlSelect.controlID )
		{
			case buttonColorAFR : UIPickColor( &new_color_afr,	NULL, UIPickColorStartPalette, "A/F", NULL );		ColorForm_DrawBars();	break;
			case buttonColorRPM	: UIPickColor( &new_color_rpm,	NULL, UIPickColorStartPalette, "RPM", NULL );		ColorForm_DrawBars();	break;
			case buttonColorVu1 : UIPickColor( &new_color_v1,	NULL, UIPickColorStartPalette, "Vuser1", NULL );	ColorForm_DrawBars();	break;
			case buttonColorVu2 : UIPickColor( &new_color_v2,	NULL, UIPickColorStartPalette, "Vuser2", NULL );	ColorForm_DrawBars();	break;
			case buttonColorSave :
			{
				color_afr	= new_color_afr;
				color_rpm	= new_color_rpm;
				color_v1	= new_color_v1;
				color_v2	= new_color_v2;

				Config_Save();
				FrmReturnToForm( 0 );
				WinPalette( winPaletteSetToDefault, 0, 0, NULL );	/* Fix palette which is mangled by UIPickColor */

				break;
			}
			case buttonColorCancel :
			{
				FrmReturnToForm( 0 );
				WinPalette( winPaletteSetToDefault, 0, 0, NULL );	/* Fix palette which is mangled by UIPickColor */

				break;
			}
		}

		return true;
	}

	return false;
}

