/*
 * FMDLog
 * Wideband O2 Display/Datalogging Application
 * For the TechEdge DIY-WB series of devices
 * (c) 2002-2003, Jonathan Burchmore
 *
 * Your use of this software is governed by the GNU General Public License, v2.
 * See the file COPYING.txt, or http://www.fsf.org/copyleft/gpl.txt
 *
 * This software is provided with ABSOLUTELY NO WARRANTY.  See the GNU General
 * public license for additional information.
 */

#include <PalmOS.h>
#include "resource.h"
#include "fmdlog.h"

/*
 * Save Log Form Functions
 */

Boolean SaveLogForm_HandleEvent( EventPtr event )
{
	FormPtr frm;
	FieldPtr field;
	Char *name_data, *notes_data;
	MemPtr recordp;
	MemHandle dbrecord;
	MemHandle nameH;
	Char *name, date[ dateStringLength ], time[ timeStringLength ];
	DateTimeType now;

	if ( event->eType == frmOpenEvent )
	{
		frm			= FrmGetActiveForm();

		nameH		= MemHandleNew( sizeof( dbrecord_desc.name ) );
		name		= MemHandleLock( nameH );

		TimSecondsToDateTime( TimGetSeconds(), &now );

		DateToAscii( now.month, now.day, now.year, dfMDYWithSlashes, date );
		TimeToAscii( now.hour, now.minute, true, time );

		StrCopy( name, date );
		StrCat( name, " " );
		StrCat( name, time );

		MemHandleUnlock( nameH );

		field		= FrmGetObjectPtr( frm, FrmGetObjectIndex( frm, textSaveLogName ) );
		
		FldSetText( field, nameH, 0, sizeof( dbrecord_desc.name ) );

		FldSetMaxChars( field, sizeof( dbrecord_desc.name ) - 1 );
		FldSetMaxChars( FrmGetObjectPtr( frm, FrmGetObjectIndex( frm, textSaveLogNotes ) ),	sizeof( dbrecord_desc.notes ) - 1 );

		FrmSetFocus( frm, FrmGetObjectIndex( frm, textSaveLogNotes ) );
		FrmDrawForm( frm );

		return true;
	}
	else if ( event->eType == ctlSelectEvent )
	{
		if ( event->data.ctlSelect.controlID == buttonSaveLogSave )
		{
			/*
			 * Update DB record with the notes from this form
			 */
			
			frm				= FrmGetActiveForm();
			field			= ( FieldPtr ) FrmGetObjectPtr( frm, FrmGetObjectIndex( frm, textSaveLogName ) );
			name_data		= FldGetTextPtr( field );
			field			= ( FieldPtr ) FrmGetObjectPtr( frm, FrmGetObjectIndex( frm, textSaveLogNotes ) );
			notes_data		= FldGetTextPtr( field );

			dbrecord		= DmGetRecord( dbP, dbrecord_first_index );
			recordp			= MemHandleLock( dbrecord );

			if ( name_data )	StrNCopy( dbrecord_desc.name,	name_data,	sizeof( dbrecord_desc.name ) - 1 );
			if ( notes_data )	StrNCopy( dbrecord_desc.notes,	notes_data,	sizeof( dbrecord_desc.notes ) - 1 );
			
			Log_Write_Desc( recordp, WBO2_RECORD_HEADER_SIZE, &dbrecord_desc );

			MemPtrUnlock( recordp );
			DmReleaseRecord( dbP, dbrecord_first_index, 1 );

			FrmReturnToForm( 0 );
			return true;
		}
		else if ( event->data.ctlSelect.controlID == buttonSaveLogDiscard )
		{
			/*
			 * Delete the DB record
			 */

			DmRemoveRecord( dbP, dbrecord_index );

			FrmReturnToForm( 0 );
			return true;
		}
	}

	return false;
}

